#!/tvbin/tivosh

source $tcl_library/tv/sendkey.tcl

# ioctl codes
set scart_ioctl(aux)  0x01
set scart_ioctl(vcr)  0x02
set scart_ioctl(tivo) 0x03

set scart_dev [open "/dev/scartmux" RDWR]
set scart_bypass 0

proc key_callback {type subtype} {
	global EventData evrc scart_dev scart_ioctl scart_bypass
	binary scan $EventData IIIII keycode modifiers id timelow timehigh
	#puts "Key: $keycode subtype=$subtype code=$keycode mod=$modifiers id=$id timelow=$timelow timehigh=$timehigh"
	if { $subtype == 0 } {
		switch -- $keycode \
			$evrc(auxbypass) - \
			$evrc(vcrbypass) {
				if { $scart_bypass == 0 } {
					if { $keycode == $evrc(auxbypass) } {
						ioctl $scart_dev $scart_ioctl(aux)
					} else {
						ioctl $scart_dev $scart_ioctl(vcr)
					}
					set scart_bypass 1
				} else {
					ioctl $scart_dev $scart_ioctl(tivo)
					set scart_bypass 0
				}
			} \
			$evrc(volumeUp) - \
			$evrc(volumeDown) - \
			$evrc(mute) { } \
			default {
				ioctl $scart_dev $scart_ioctl(tivo)
				set scart_bypass 0
			}
	} else {
		set tty [open "/dev/ttyS0" WRONLY]
		if { $scart_bypass == 0 } {
			puts $tty \x50
		} else {
			after 50
			puts $tty \x51
			puts $tty \x60
		}
		close $tty
	}
}

event register $TmkEvent::EVT_REMOTEEVENT key_callback

vwait wakeup

