#!/tvbin/tivosh
#
# Hack DTivo/Tivo live buffer from 30 to 45 to 60 to ??? minutes
#
# Modified 07/31/2003 for version-specific group and item values by JJBliss
# Suggestions/information/code from:
#         BlackWidow000, Alphawolf, kaustic, embeem, PGM,
#         DarkHelmet, cashion, NutKase, and SR712
#
# Greetz to all the dealdatabase guys: mrblack51, KRavEN, alldeadhomiez, 
#                                      jdiner, rc3105 & Vadim
#

###############################################################################
#                   TERMS OF USE
#
#  BUFFERHACK IS PROVIDED AS-IS 
#  AND DOES NOT CARRY ANY IMPLIED OR EXPLICIT WARRANTY
#
# -BUFFERHACK IS FOR NON-COMMERCIAL USE ONLY.  
# -YOU MUST BACKUP YOUR UNIT BEFORE USING THIS SCRIPT 
#  AS IT MAY DAMAGE YOUR TIVO BEYOND REPAIR.
# 
# -SALE OF ANY DRIVE OR WHOLE UNIT MODIFIED WITH THIS SOFTWARE IS PROHIBITED
# -USE OF THIS SOFTWARE FOR PROFIT IS PROHIBITED
# -INDIVIDUALS IN VIOLATION OF THE TERMS LISTED ABOVE 
#  WILL BE PROSECUTED TO THE FULLEST EXTENT OF THE LAW
# 
#
###############################################################################

set do eval
#set do puts      ;# debug

EnableTransactionHoldoff true

# universal resource IDs for 3.x & 4.x
set grpid 1507328
set resid 1507369

proc puts_txt { str level } {
  global textlvl

  if { $level >= $textlvl } {
       puts $str
  }
}

proc findid { db itemlist id } {
  foreach x $itemlist {
      if { [dbobj $x get Id] == $id } {
              return $x
      }
  }
  return ""
}

proc prompt {} {
  set choice ""
  while {$choice==""} {
    puts -nonewline "Choice? "
    flush stdout
    gets stdin choice
  }
  return $choice
}

switch [lindex $argv 1] {
        "q" {
              set textlvl 1 }
        "s" {
              set textlvl 2 }
        default {
              set textlvl 0 }
}


puts_txt " " 0
puts_txt "Buffer Hack 3.0" 0
puts_txt "(C) 8/23/2004 by JJBliss/jeboo/black_widow000/MuscleNerd" 0
puts_txt "All credit goes to embeem, Alphawolf,alldeadhomiez," 0
puts_txt "BlackWidow000, bsnelson, DarkHelmet, MuscleNerd, PGM, SR712, kaustic and cashion" 0
puts_txt "And ESPECIALLY jeboo or the tivoapp patches that fix the play bar issues " 0
puts_txt "present with all the bufferhack 1.xx code and MuscleNerd for showing me how" 0
puts_txt "to script tivoapp patches" 0
puts_txt " " 0
puts_txt "All support for 2.5.1 has been pulled from this" 0
puts_txt "all future versions of bufferhack" 0
puts_txt " " 0

#      Version           addrA     addrB     addrC     addrD     filesize
# series1
set sys(2.5.2)     [list 0x2cff42  0x2cfd1a  0x3129ae  0x3129b2  5612128]
set sys(3.0)       [list 0x3de7c2  0x3de56e  0x4405e2  0x4405e6  6575372]
set sys(3.1.0-01)  [list 0x3fe03e  0x3fde22  0x45aa8a  0x45aa8e  6670628]
set sys(3.1.0b)    [list 0x3fe12e  0x3fdf12  0x45ab7a  0x45ab7e  6671748]
set sys(3.1.0c)    [list 0x3fe17a  0x3fdf5e  0x45ac4a  0x45ac4e  6671876]
set sys(3.1.0c2)   [list 0x3fe17a  0x3fdf5e  0x45abc6  0x45abca  6671748]
# series2
set sys(3.1.0)     [list 0x3127be  0x312376  0x54169e  0x5416a2  12405408]
set sys(3.1.1b)    [list 0x31304e  0x312c06  0x54359e  0x5435a2  12423536]
set sys(3.1.1c)    [list 0x31301e  0x312bd6  0x54356e  0x543572  12428016]
set sys(3.1.5)     [list 0x339f76  0x339b2e  0x571bee  0x571bf6  13258208]
set sys(4.0)       [list 0x51641e  0x515fde  0x726166  0x72616a  16424968]
set sys(4.0.1b)    [list 0x51b8de  0x51b49e  0x72bf86  0x72bf8a  16449560]

set addrA 0   
set addrB 0
set addrC 0
set addrD 0
set tvapp 0

set db [dbopen]
RetryTransaction {
    set swsysa [db $db open /SwSystem/ACTIVE]
    set tivoswversion [dbobj $swsysa get Name]
}
dbclose $db

puts_txt "Checking tivoapp version..." 0
set tappsz [file size "/tvbin/tivoapp"]
foreach v [array names sys] {
        if { $tappsz == [lindex $sys($v) 4] } {
                        puts_txt "Your TiVo version is supported ($v)\n" 0
        		set addrA  [lindex $sys($v) 0]
        		set addrB  [lindex $sys($v) 1]
                        set addrC  [lindex $sys($v) 2]
                        set addrD  [lindex $sys($v) 3]
    }
	    if { $tappsz == 6671748 } {
                puts_txt "Your Series 1 TiVo is running either 3.1.0b or 3.1.0c2" 0
                puts_txt "confirming now.........." 0
    			if { [PrefixMatches "3.1.0b" $tivoswversion] } {
                                puts_txt "Version 3.1.0b" 0
				set addrA  [lindex $sys(3.1.0b) 0]
                                set addrB  [lindex $sys(3.1.0b) 1]
                                set addrC  [lindex $sys(3.1.0b) 2]
                                set addrD  [lindex $sys(3.1.0b) 3]
				}
			if { [PrefixMatches "3.1.0c2" $tivoswversion] } {
                                puts_txt "Version 3.1.0c2" 0
				set addrA  [lindex $sys(3.1.0c2) 0]
        			set addrB  [lindex $sys(3.1.0c2) 1]
                                set addrC  [lindex $sys(3.1.0c2) 2]
                                set addrD  [lindex $sys(3.1.0c2) 3]
				}  	
    	}
    		
}

# ADDED by BlackWidow000 for MFS value adjustment
switch -exact -- $tappsz {
	5612128 { 
		  set grpid 1638400
		  set resid 1638439 
                  puts_txt "Adjusted MFS values for 2.5.2" 0} 
	6575372 { 
		  set grpid 1572864
		  set resid 1572905
                  puts_txt "Adjusted MFS values for 3.0" 0}
	default { 
                  puts_txt "Using Universal MFS Values" 0}
}	

if { $addrA == 0 } {
    puts_txt "Your tivoapp version is not recognized. The buffer can be changed, but the playbar will not be corrected.\n" 1
}

if {[lindex $argv 0] <= 0} {

puts_txt "Please choose from one of the following options:" 0
set choice 0
 while { $choice < 1 || $choice > 5 }  {
    puts_txt "" 0
    puts_txt "-- Menu --" 0
    puts_txt "1. Set buffer to 30 minutes" 0
    puts_txt "2. Set buffer to 45 minutes" 0
    puts_txt "3. Set buffer to 60 minutes" 0
    puts_txt "4. Set User-defined buffer" 0
    puts_txt "5. Quit" 0
    puts_txt " " 0
    set choice [prompt]
    switch -exact $choice {
      1 {
	set buffern 1800
 	set buffernstring "30 Minutes"
	}
      2 {
	set buffern 2700 
	set buffernstring "45 Minutes"
	}
      3 {
	set buffern 3600 
	set buffernstring "60 Minutes"
	}
      4 {
        puts_txt " " 0
        puts_txt " " 0
        puts_txt " " 0
        puts_txt "This option allows users to enter" 0
        puts_txt "the buffer amount desired in minutes" 0
        puts_txt " " 0
        puts_txt " " 0
        set userbuffer ""
        while {$userbuffer==""} {
          puts -nonewline "Enter the number of minutes: "
          flush stdout
          gets stdin userbuffer
        }
        set buffern [expr $userbuffer * 60]
	set buffernstring "$userbuffer Minutes"
	}
      5 {
        puts_txt "leaving!" 0
	exit
	}
    }
 }
} else {
        set userbuffer [expr [lindex $argv 0]]
        set buffern [expr $userbuffer * 60]
        set buffernstring "$userbuffer Minutes"
        puts_txt "Using commandline value: $buffernstring" 0
 }

set db [dbopen]
RetryTransaction {
  set swsys [db $db open /SwSystem/ACTIVE]
  set grplist [dbobj $swsys get ResourceGroup]
  set grp [findid $db $grplist $grpid]
  set item [findid $db [dbobj $grp get Item] $resid]
  dbobj $grp remove "CompressedFile"
  set curval [dbobj $item get String]
  dbobj $item set String $buffern

  puts_txt "\nAdjusted resources (valid after next reboot)" 0
}
dbclose $db

if { $addrA == 0 } {
    puts_txt "\nNo tivoapp patch is available for this system" 1
    exit 1
}

# Store a backup of the tivoapp & set one up for patching

puts_txt "Patching tivoapp..." 0
$do {cp /tvbin/tivoapp /tvbin/tivoapp.backup}
$do {cp /tvbin/tivoapp /tvbin/tivoapp.bufferhack}


# Fix the play bar LENGTH (to double the selected buffern)

binary scan [format "%04x" [expr $buffern * 2]] a2a2 b0 b1
set cmd "echo -ne \"\\x$b0\\x$b1\" | dd conv=notrunc of=/tvbin/tivoapp.bufferhack bs=1 seek=[expr $addrA]"
puts_txt $cmd 0
set res ""
$do {catch {exec sh -c $cmd} res}
puts_txt $res 0

# Fix the playbar CENTER (to the selected buffern in minutes)

binary scan [format "%04x" [expr $buffern / 60]] a2a2 b0 b1
set cmd "echo -ne \"\\x$b0\\x$b1\" | dd conv=notrunc of=/tvbin/tivoapp.bufferhack bs=1 seek=[expr $addrB]"
puts_txt $cmd 0
set res ""
$do {catch {exec sh -c $cmd} res}
puts_txt $res 0

# Part File size increase
if { [info exists addrC] && [info exists addrD]} {

	binary scan [format "%08x"  [expr ($buffern / 60) * 6962]] a2a2a2a2 b0 b1 b2 b3
	
        # Write MSB
	
	set cmd "echo -ne \"\\x$b0\\x$b1\" | dd conv=notrunc of=/tvbin/tivoapp.bufferhack bs=1 seek=[expr $addrC]"
	puts_txt $cmd 0
	set res ""
	$do {catch {exec sh -c $cmd} res}
	puts_txt $res 0

	# Write LSB

	set cmd "echo -ne \"\\x$b2\\x$b3\" | dd conv=notrunc of=/tvbin/tivoapp.bufferhack bs=1 seek=[expr $addrD]"
	puts_txt $cmd 0
	set res ""
	$do {catch {exec sh -c $cmd} res}
	puts_txt $res 0
}


# Now put the patched tivoapp.bufferhack into production

$do {
    file rename -force /tvbin/tivoapp  /tvbin/tivoapp.tmp;
    file rename -force /tvbin/tivoapp.bufferhack /tvbin/tivoapp;
}

puts_txt "tivoapp has been patched to properly display a buffer with $buffernstring" 0
